unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs,
  opbitmap, opimglib, lazbridge, lazbridge32;

type

  { TForm1 }

  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: integer);
    procedure FormPaint(Sender: TObject);
  private
    { private declarations }
    fMoving: TCanvasOpBitmap;
    fBack: TCanvasOpBitmap;
    fX: integer;
    fY: integer;
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

function CreateAndLoadOpBitmap(const FileName: string): TCanvasOPBitmap;
var
  Bmp: TPicture;
begin
  Result := TCanvasOPBitmap.Create;
  Bmp := TPicture.Create;
  Bmp.LoadFromFile(FileName);
  lazbridge.AssignBitmapToOpBitmap(Bmp.Bitmap, Result);
  Bmp.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DoubleBuffered := True;
  fMoving := CreateAndLoadOpBitmap('maske.png');
  opimglib.BlackToAlpha(fMoving);
  OpBitmapPreMultiply(fMoving, fMoving);
  fBack := CreateAndLoadOpBitmap('loue.jpg');
  Width := fBack.Width;
  Height := fBack.Height;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  fMoving.Free;
  fBack.Free;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: integer);
begin
  fX := X - (fMoving.Width div 2);
  fY := Y - (fMoving.Height div 2);
  Invalidate;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  OpBitmapPaint32A(fBack, Canvas, 0, 0, True);
  OpBitmapPaint32A(fMoving, Canvas, fX, fY, True);
end;

end.
